# -*- coding: utf-8 -*-
from setuphelpers import *
import json

# registry key(s) where WAPT will find how to remove the application(s)
uninstallkey = []

def install():

    version = control['version'].split('-',1)[0]
    if iswin64():
        if installed_softwares('HandBrake'):
            key = WAPT.uninstall_cmd('HandBrake')
            if r'C:\Program Files (x86)' in key[0]:
                 run(WAPT.uninstall_cmd('HandBrake'))
        install_exe_if_needed('HandBrake-%s-x86_64-Win_GUI.exe' % version,silentflags='/S -',key='HandBrake',min_version=version,killbefore=['HandBrake.exe'])

    remove_desktop_shortcut('HandBrake')


def update_package():
  
    # Getting proxy informations from WAPT settings
    proxy = {}
    if isfile(makepath(user_local_appdata(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxy = {'http':proxywapt,'https':proxywapt}
    binaryfile,urlfile  = [(str(p['name']),str(p['browser_download_url'])) for p in json.loads(wgets('https://api.github.com/repos/HandBrake/HandBrake/releases/latest',proxies=proxy))['assets'] if '-x86_64-Win_GUI.exe' in p['name']][0]

    if not isfile(binaryfile):
        wget(urlfile,binaryfile,proxies=proxy)

    for f in glob.glob('*.exe'):
        if f != binaryfile:
            remove_file(f)

    lastversion = binaryfile.split('-')[-3]
    print('Last Version %s' % lastversion)

    pe = PackageEntry()
    pe.load_control_from_wapt(os.getcwd())
    pe.version = lastversion + '-0'
    pe.save_control_to_wapt(os.getcwd())

if __name__ == '__main__':
    update_package()


